﻿using Sample.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.Linq;

namespace Sample.Controllers
{
    public partial class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            ViewBag.data = OrderRepository.GetAllRecords().ToList(); 
            return View();
        }
        public ActionResult DataSource(DataManager dm)
        {
            IEnumerable DataSource = OrderRepository.GetAllRecords();
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            List<string> select = new List<string>(); 
               
               result.result = DataSource;
                if (dm.Where != null)
                {
                    result.result = operation.PerformWhereFilter(result.result, dm.Where, "and");
                }
                if (dm.Sorted != null)
                {
                    result.result = operation.PerformSorting(result.result, dm.Sorted);
                }
                result.count = result.result.AsQueryable().Count();
                if (dm.Skip > 0)
                    result.result = operation.PerformSkip(result.result, dm.Skip);

                if (dm.Take > 0)
                    result.result = operation.PerformTake(result.result, dm.Take);
                if (dm.Aggregates != null)
                {
                    foreach (var item in dm.Aggregates)
                    {
                        select.Add(item.Field);
                    }
                    var data = operation.PerformSelect(result.result, select);
                    result.aggregate = data;
                }
                return Json(result, JsonRequestBehavior.AllowGet);
            }
        public ActionResult BatchUpdate(List<EditableOrder> changed, List<EditableOrder> added, List<EditableOrder> deleted)
        {
            if (changed != null)
                OrderRepository.Update(changed);
            if (deleted != null)
                OrderRepository.Delete(deleted);
            if (added != null)
                OrderRepository.Add(added);
            var data = OrderRepository.GetAllRecords().Take(20);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable aggregate { get; set; }
        }
    }

}
